/*****************************************************************************
    process.h

    Diese Datei ist Teil des Programmpakets 'ACL-tftp'.
    Alle Rechte bei Andreas G. Schindler
                    Klappacher Str. 2i
                    64285 Darmstadt, Deutschland.

    Dieses Programm ist 'Freie Software'; Sie knnen es entsprechend den 
    Bedingungen der 'Allgemeinen ffentlichen GNU-Lizenz' (verffentlicht 
    durch die 'Free Software Foundation') weiter verbreiten und/oder 
    modifizieren. Massgeblich ist die Version 2 oder eine neuere Version
    dieser Lizenz. 

    Dieses Programm wird in der Hoffnung dass es ntzlich is weitergegeben,
    jedoch OHNE JEDE GARANTIE. Dieser Garantieauschluss bezieht sich auch
    auf Eigenschaften wie Marktfhigkeit oder Eignung zu einem bestimmten
    Zweck. Details finden sich in der 'Allgemeinen ffentlichen GNU-Lizenz'.

    Eine Kopie dieser Lizenz sollte in  Programmpaket, dem diese Datei
    entstammt, enthalten sein. Falls nicht, schreiben Sie an die 
    'Free Software Foundation, Inc.', 59 Temple Place, Suite 330, Boston, 
    MA  02111-1307  USA.


    This file is part of the 'ACL-tftp' Package
    Copyright (C) 1999-2005 by Andreas G. Schindler
                               Klappacher Str. 2i
                               Darmstadt, Germany.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************/
#ifndef PROCESS_H
#define PROCESS_H

#include <sys/types.h>
#include <unistd.h>
#include "netio.h"
#include "sigmask.h"
/*
	Signal mask coding:	MIN_SET	Base set of signals to be catched
				PAR_SET	Signals catched in parent process
				CHL_SET	Signals catched in child process
*/
#ifdef HAVE_BACKTRACE
#define MIN_SET	(M_TERM|M_INT|M_SEGV)
#define PAR_SET (M_TERM|M_INT|M_CHLD|M_HUP|M_USR1|M_USR2|M_SEGV)
#define CHL_SET (M_TERM|M_INT|M_CONT|M_USR1|M_USR2|M_SEGV|M_QUIT|M_PIPE)
#else
#define MIN_SET	(M_TERM|M_INT)
#define PAR_SET (M_TERM|M_INT|M_CHLD|M_HUP|M_USR1|M_USR2)
#define CHL_SET (M_TERM|M_INT|M_CONT|M_USR1|M_USR2|M_QUIT|M_PIPE)
#endif

void registerConn (sopair_t *sp, tftpR_t *req);
void unregisterConn (void);
void bit2sigMask(ulong bitmask, sigset_t *smask);
int signalSetup(ulong mask, int quiet);
int signalReset(ulong mask);
void processRundown(void);
int procEnvSetup(void);
int becomeDaemon(void);
pid_t doFork(int dolog);
pid_t sSpawn(int mark, sai_t *peer);
void changeIdent(void);
void resetIdent(void);
int forkFilter (struct tftpR_s *request, int *ds);
void killChild(sai_t *peer);
int checkPidFile(void);
void statsRequest(void);
int setCore(void);
void sigBlock(int signum);
void sigUnblock(int signum);

#endif /* PROCESS_H */
